/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.gruppe.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.gruppe.entity.PolitischeGruppe;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class PolitischeGruppeExtendedDAO extends AbstractPolitischeGruppeDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: OhneWahlNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT gruppe FROM PolitischeGruppe gruppe WHERE gruppe.wahl IS NULL ORDER BY gruppe.schluessel<br>
* SQL: <br>
*/
@Override
public java.util.List<PolitischeGruppe> findByOhneWahl() {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("PolitischeGruppe.findByOhneWahl"  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByOhneWahl(): Miss");
        }

        cache.put(key, super.findByOhneWahl( ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByOhneWahl(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<PolitischeGruppe>) cache.lookup(key));
    }

    return super.findByOhneWahl( );
}
/**
* Name: WahlAndGruppeArtenNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT gruppe FROM PolitischeGruppe gruppe WHERE gruppe.wahl = ?1 AND gruppe.gruppeArt IN (?2) ORDER BY gruppe.schluessel<br>
* SQL: <br>
*/
@Override
public java.util.List<PolitischeGruppe> findByWahlAndGruppeArten( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.gruppe.entity.GruppeArt> gruppeArten) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("PolitischeGruppe.findByWahlAndGruppeArten" ,  wahl ,  gruppeArten  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahlAndGruppeArten(): Miss");
        }

        cache.put(key, super.findByWahlAndGruppeArten( wahl ,  gruppeArten  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahlAndGruppeArten(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<PolitischeGruppe>) cache.lookup(key));
    }

    return super.findByWahlAndGruppeArten( wahl ,  gruppeArten  );
}
/**
* Name: WahlNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT gruppe FROM PolitischeGruppe gruppe WHERE gruppe.wahl = ?1 ORDER BY gruppe.schluessel<br>
* SQL: <br>
*/
@Override
public java.util.List<PolitischeGruppe> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("PolitischeGruppe.findByWahl" ,  wahl  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahl(): Miss");
        }

        cache.put(key, super.findByWahl( wahl  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahl(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<PolitischeGruppe>) cache.lookup(key));
    }

    return super.findByWahl( wahl  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
